#
# gtkadd.rb
#
#   Copyright (c) 2001,2002 Minero Aoki <aamine@loveruby.net>
#
#   This program is free software.
#   you can distribute/modify this program under the terms of
#   the GNU General Public License version 2 or later.
#

module Gtk

  class Object
    def signal_handler( name )
      signal_connect( name ) {|args|
        begin
          yield args
        rescue StandardError, ScriptError => err
          $stderr.puts "#{err.type} in '#{name}' signal handler"
          $stderr.puts err.message
          err.backtrace.each do |i|
            $stderr.puts i
          end
        end
      }
    end
  end

  class CList
    def select( row )
      select_row [[row, self.rows - 1].min, 0].max, 0
    end
  end

  class Tree
    def selection_mode=( flag )
      set_selection_mode flag
    end
  end

end
