#
# view.rb
#
#   Copyright (c) 2001 Minero Aoki <aamine@loveruby.net>
#
#   This program is free software.
#   you can distribute/modify this program under the terms of
#   the GNU General Public License version 2 or later.
#

module Delta

  class View

    def detach
      @mbox.detach self
    end
  

    def init2( dir )   # called before showing
      @cache_dir = dir

      if File.file? cachefilename() then   # cached
        begin
          File.open(cachefilename()) {|f|
              init2__cached f
          }
        rescue
          init2__cache_failed
          init2__parse
        end
      else
        init2__parse
      end
      @init2_initialized = true
    end

    def view_initialized?
      defined? @init2_initialized
    end

    def finalize
      return unless defined? @init2_initialized
      begin
        File.open(cachefilename(), 'w') {|f|
            finalize__cache f
        }
      rescue
        begin
          File.unlink cachefilename()
        rescue Errno::ENOENT
          # ignore
        end
      end
    end

    def cachefilename
      sprintf '%s/%s__%s__%d',
              @cache_dir,
              self.identifier, self.class.name, self.class::CACHE_VERSION
    end


    def port_error!( port )
      raise ArgumentError, "no such port: #{port.inspect}"
    end

  end

end
